package com.docus.server.infrastructure.dao.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.docus.core.util.Func;
import com.docus.infrastructure.core.db.dao.impl.BaseDaoImpl;
import com.docus.infrastructure.web.request.SearchDTO;
import com.docus.infrastructure.web.response.PageResult;
import com.docus.server.entity.segmentation.OcrFileInfoTest;
import com.docus.server.infrastructure.dao.IOcrFileInfoTestDao;
import com.docus.server.infrastructure.mapper.OcrFileInfoTestMapper;
import com.github.pagehelper.PageHelper;
import org.springframework.stereotype.Repository;

import java.util.Date;
import java.util.List;

/**
 * ocr文件信息-调试 数据访问实现类
 *
 * @author AutoGenerator
 * @since 2023-08-29
 */
@Repository
public class OcrFileInfoTestDaoImpl extends BaseDaoImpl<OcrFileInfoTestMapper, OcrFileInfoTest> implements IOcrFileInfoTestDao {


    /**
     * 按主键查询
     *
     * @param id 主键Id
     * @return 实体
     */
    @Override
    public OcrFileInfoTest findById(Long id) {
        return super.findById(id);
    }

    /**
     * 新增
     *
     * @param ocrFileInfoTest 编辑参数
     * @return 成功或失败
     */
    @Override
    public boolean add(OcrFileInfoTest ocrFileInfoTest) {
        return super.save(ocrFileInfoTest);
    }

    /**
     * 编辑
     *
     * @param ocrFileInfoTest 编辑参数
     * @return 成功或失败
     */
    @Override
    public boolean edit(OcrFileInfoTest ocrFileInfoTest) {
        return super.updateById(ocrFileInfoTest);
    }

    /**
     * 批量删除
     *
     * @param ids 主键ids
     * @return 成功或失败
     */
    @Override
    public int delete(List<Long> ids) {
        return super.deleteByIds(ids);
    }

    /**
     * 关键字搜索
     *
     * @param searchDTO 搜索参数
     * @return 分页列表
     */
    @Override
    public PageResult<OcrFileInfoTest> search(SearchDTO searchDTO) {
        //分页
        PageHelper.startPage(searchDTO.getPageNum(), searchDTO.getPageSize());
        LambdaQueryWrapper<OcrFileInfoTest> query = Wrappers.lambdaQuery();
        //时间范围，默认按createTime
        if (searchDTO.getBeginTime() != null) {
            query.ge(OcrFileInfoTest::getCreateTime, searchDTO.getBeginTime());
        }
        if (searchDTO.getEndTime() != null) {
            Date endTime = searchDTO.getEndTime();
            query.le(OcrFileInfoTest::getCreateTime, endTime);
        }
        Object patientId = searchDTO.getParams("patientId");
        if (Func.isNotEmpty(patientId)) {
            query.eq(OcrFileInfoTest::getPatientId, patientId);
        }
        //默认createTime倒序排序
        query.orderByDesc(OcrFileInfoTest::getCreateTime);
        List<OcrFileInfoTest> list = super.find(query);
        return new PageResult<>(list);
    }

    /**
     * 名称不重复
     *
     * @param id   主键
     * @param name 名称
     * @return 名称重复数量
     */
    @Override
    public int findByIdAndName(Long id, String name) {
        LambdaQueryWrapper<OcrFileInfoTest> query = Wrappers.lambdaQuery();
        if (id != null) {
            query.ne(OcrFileInfoTest::getId, id);
        }
        //if (Func.isNotBlank(name)) {
        //   query.eq(OcrFileInfoTest::getName, name);
        //}

        return baseMapper.selectCount(query);
    }
}
